%define jboss_seam_home %{_localstatedir}/lib/jboss-seam
%define shortname seam

Name:           jboss-seam
Version:        1.2.0
Release:        1.AP.ep1.19%{?dist}
Summary:        JBoss Seam
License:        LGPL
Group:          Development
URL:            http://labs.jboss.com/portal/jbossseam/
Source0:        jboss-seam-1.2.0.AP.tar.gz
#cvs -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r Seam_1_2_AP jboss-seam
#tar czvf jboss-seam-1.2.0.AP.tar.gz jboss-seam
Source1:        jboss-seam-build.properties
Patch0:         jboss-seam_build_xml.patch
BuildArch:      noarch

BuildRequires: java
BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: ant
BuildRequires: ant-nodeps
BuildRequires: ant-junit

Requires:       jbossas >= 4.2.0
Requires:       java
Requires:       jpackage-utils

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
JBoss Seam is a powerful new application framework for building
next generation Web 2.0 applications by unifying and integrating
technologies such as Asynchronous JavaScript and XML (AJAX),
Java Server Faces (JSF), Enterprise Java Beans (EJB3),
Java Portlets and Business Process Management (BPM).

%package docs
Summary:        Documentation for %{name}
Group:          Development/Documentation

%description docs
Documentation for %{name}.

%package zip
Summary:        Zip file for %{name}
Group:          Development

%description zip
Zip file for %{name}.

%package src-zip
Summary:        Container for the sources for %{name}
Group:          Development

%description src-zip
Container for the sources for %{name}.

%prep
%setup -q -n %{name}
cp %{SOURCE1} build.properties
%patch0 -p0
for i in `find . -name ".cvsignore"`
do
    rm -fr $i
done
zip -q -r seam-src.zip *

%build
ant cleanall dist testall

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_localstatedir}/lib/

pushd dist
#fix JBPAPP-58
for i in `find . -name "readme.txt"`; do rm -f $i; done
#get rid of seam-gen
for j in `find . -name "*seam-gen*"`; do rm -fr $j; done
rm -f seam seam.bat
popd

cp -pr dist/* $RPM_BUILD_ROOT%{_datadir}/%{name}
# do not put doc in main package, leave that in docs
rm -fr $RPM_BUILD_ROOT%{_datadir}/%{name}/doc
ln -sf %{_datadir}/%{name} $RPM_BUILD_ROOT%{_localstatedir}/lib

#for the zip
rm -fr tmp
mkdir -p tmp tmp/doc/seam/api
cp -pr dist/doc/api tmp/doc/seam
pushd tmp
mkdir -p seam
cp -pr ../dist/* seam/
rm -fr seam/doc
popd

#get rid of seam-gen
#for jar in jboss-seam-debug jboss-seam-gen jboss-seam jboss-seam-ui jboss-seam-mail jboss-seam-pdf
for jar in jboss-seam-debug jboss-seam jboss-seam-ui jboss-seam-mail jboss-seam-pdf
do
    ln -sf %{_datadir}/%{name}/$jar.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/$jar-%{version}.jar
done

#create all versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

#docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/doc/api $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/doc/reference $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

pushd tmp
zip -r seam.zip seam
zip -r seam-api-docs.zip doc
install -d -m 755 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev
install -m 644 seam.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}.zip
install -m 644 seam-api-docs.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}-api-docs.zip
rm seam.zip seam-api-docs.zip
popd
rm -fr tmp
install -m 644 seam-src.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}-src.zip

%files
%defattr(-, jboss, jboss, -)
%{_javadir}/%{name}
%{_datadir}/%{name}/[a,c-z]*
%{_datadir}/%{name}/build.xml
%config(noreplace) %{_datadir}/%{name}/build.properties
%{jboss_seam_home}

%files docs
%defattr(-, root, root, -)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}
%doc changelog.txt lgpl.txt

%files zip
%defattr(-, root, root, -)
%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}.zip
%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}-api-docs.zip

%files src-zip
%defattr(-, root, root, -)
%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}-src.zip

%changelog
* Tue Jun 26 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.19
- Rename src.zip and api-docs.zip

* Wed Jun 20 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.18
- Add src-zip supackage which contains the src zip

* Thu Jun 14 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.17
- Update connection-url in hibernate example ds to avoid conflict with booking
  example
- Update src tar ball with the changes committed
                                                                                
* Thu Jun 14 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.16
- Move Seam up one directory in the rpm
                                                                                
* Wed Jun 13 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.15
- Move Seam up one directory in the zip

* Tue May 29 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.14
- Rebuild

* Tue May 29 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.12
- Less verbose logging from Seam/Hibernate in the examples.

* Fri Apr 13 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.11
- Update src tar ball

* Thu Apr 12 2007 Permaine Cheung <pcheung@redhat.com> 1.2.0-1.AP.ep1.10
- Put javadoc into _javadocdir
- Add perm gen settings to seam-examples.html 

* Thu Apr 12 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.9
- Exclude reference guide as it will be included in a separate srpm
- Put doc/api into a separate zip

* Wed Apr 11 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.8
- More examples fixing

* Tue Apr 10 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.7
- Fix more examples

* Mon Apr 09 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.6
- Fix booking example by extracting the beanutils.jar and get rid of the 
  collections classes in there to avoid classloading problem, and not removing
  el-ri.jar in application.xml
- No need to restart jbossas after install/uninstall

* Wed Apr 04 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.5
- Update zip structure
- Move the commons*jar into WEB-INF/lib dir for the examples uses ajax4jsf,
  and update build.xml accordingly to pick up the changes.
- Remove the doc directory from the zip
- Added Seam_Reference_Guide.pdf

* Wed Apr 04 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.4
- No examples are deployed by default
- Leave out commons-el-1.0 and el-api when copying jars to server config
- Make production config a variable

* Fri Mar 30 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.3
- Remove production config

* Fri Mar 30 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.2
- Add production config
- Fix examples

* Fri Mar 23 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-1.AP.ep1.1
- Fix Release tag
- Relocate zip file
- Add el*jars to jsf-libs dir in the zip
- Checkout from source and build from that tar ball
- Add post and postun for restarting jbossas after install/upgrade/uninstall
- Remove pre-deployed examples in the zip

* Mon Mar 19 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-0.2.ap.el4ep1.2
- Rebuilt from source

* Mon Mar 19 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-0.2.ap.el4ep1.1
- Use Seam_1_2_AP branch

* Fri Mar 16 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-0.1.p1.el4ep1.3
- Get rid of the seam and the seam.bat script to get rid of seam-gen

* Fri Mar 16 2007 Permaine Cheung <pcheung at redhat.com> 1.2.0-0.1.p1.el4ep1.2
- Get booking example to work with JSF 1.2 RI and jira JBPAPP-58
- Get rid of seam-gen

* Fri Mar 09 2007 Deepak Bhole <dbhole@redhat.com> 1.2.0-0.1.p1.el4ep1.1
- Update to 1.2.0.PATCH1
- Add missing entry in files section

* Wed Feb 28 2007 Permaine Cheung <pcheung at redhat.com> - 1.1.6-1.0.el4ep1.2
- Rebuild

* Wed Feb 28 2007 Permaine Cheung <pcheung at redhat.com> - 1.1.6-1.0.el4ep1.1
- Initial rpm build
